Unity should facilitate end-user mapping of the Super key

Reported by Jerone Young on 2010-09-07
16
This bug affects 3 people
Affects Status Importance Assigned to Milestone
Ayatana Design
Undecided
Oren Horev
OEM Priority Project
High
Ying-Chun Liu
Unity
High
Ying-Chun Liu
unity (Ubuntu)
Undecided
Unassigned
Declined for Maverick by Sebastien Bacher

Bug Description

Unity uses the Super key to activate Unity functions. Some OEM's have contractual requirements from Microsoft that pay them to put the Windows logo on that key, and preclude them from shipping the key mapped to anything other than the Windows Start menu. Unity should be usable in cases where the OEM ships it unmapped, facilitating the user's mapping of the key to Unity's requirements.

* If you would like more information on this please contact Pat in Canonical OEM services.

Related branches

Jerone Young (jerone) on 2010-09-07
Changed in oem-priority:
status: New → Confirmed
importance: Undecided → High

 On 07/09/10 19:17, Jerone Young wrote:
> Currently Unity is mapping the Windows key to display numbers for icons.

It's the Super key, and it's a standard feature of keyboards since long
before Microsoft asked people to put a Windows logo on it ;-)

We know that we need to be able to ship it inactive, and intend to allow
and facilitate users to map it themselves. I'm going to retitle the bug
accordingly.

Mark

summary: - Unity cannot map the Super (Windows) key
+ Unity should facilitate end-user mapping of the Super key
description: updated
David Barth (dbarth) wrote :

Adding the task to the backlog. It's pass feature freeze and I think it can be delivered for OEM on the 0.2 trunk, but out of schedule.

Changed in unity:
importance: Undecided → High
milestone: none → backlog
Jerone Young (jerone) wrote :

Hi all,
         One big OEM is going to ship Unity on 10.10 in there factories. This cannot wait, as they will need it on release date.

Mark Shuttleworth (sabdfl) wrote :

Jerone, please ask Pat to assign someone to this from the OEM team.

Mark

Jerone Young (jerone) wrote :

Baseline requirement:
     - Need ability to disable default mapping of super (windows) key

Full Featured requirement:
      - GUI to allow end user to map key back to function

We mainly need a way to meet the baseline requirement. Currently I'm only aware of one function that Unity uses the super key for. That is to display number that will allow a user to press a number key to take action on a launcher. I demonstrate it in this video (at 19 sec .. quality a little bad):
http://people.canonical.com/~jerone/launchpad/unity/IMG_1115.MOV

Can someone provide if there are any other uses of the Super Key by Unity or a page of Unity key mappings?

Bill Filler (bfiller) wrote :

Give the short time frame, I propose adding logic to Unity that defines and checks a new gconf key to decide if super key functionality should be enabled or disabled in Unity. Default would be enabled and for OEM builds we can disable as needed.

We can provide a patch with this functionality to the DX team if this is acceptable.

@dbarth
which package implements the Unity Super key functionality?

Also, any preference on name of gconf key?

Changed in oem-priority:
assignee: nobody → Ying-Chun Liu (paulliu)
Ying-Chun Liu (paulliu) wrote :

Should we just use xmodmap??

xmodmap -e 'keycode 133 = NoSymbol' # to disable that key.
xmodmap -e 'keycode 133 = Super_L' # re-enable that key.

Mark Shuttleworth (sabdfl) wrote :

Rather than having a GUI for the mapping, please map the key
automatically when the Dash is first invoked, say by a press of the
Ubuntu button.

Mark

Tony Espy (awe) wrote :

I just want to be sure everyone understands the three options on the table, as there's been some confusion internally...

First, as I understand it, currently the only function tied to the Super key in Unity, is the raising of an application's window by using Super + a numeric key ( used to index the currently running applications ).

As there's a legal requirement that OEM pre-installs not enable software functions tied to the Super key due to contract/legal restrictions involving the Windows logo, the following proposals have been made:

1. Disable the Super key function(s) in Unity by default. Re-enable the function when the user first initiates an action ( e.g. pressing the Ubuntu button ) which causes the Dash(board) to be displayed.

2. Add a Unity-specific GConf key which Unity reads to determine if the Super key function(s) should be disabled. This would be set to disabled on OEM pre-installs.

3. Use X11 xmodmap command to disable the Super key altogether on OEM pre-installs.

Jerone Young (jerone) wrote :

@Tony
    The problem with option #1 is we would need lawyers to qualify if it is doable using this method to meet requirement for OEMs. This would be timely process, and more then likely would not make it for the 10.10 cut off.

Mark Shuttleworth (sabdfl) wrote :

 On 14/09/10 16:45, Tony Espy wrote:
> First, as I understand it, currently the only function tied to the
> Super key in Unity, is the raising of an application's window by using
> Super + a numeric key ( used to index the currently running applications
> ).

No, to be clear, ALL Unity-specific functions are activated through the
Super key.

We can certainly support that the key is not active when the OEM ships
the device. However, there's no reason not to make activating it simple
and straightforward based on the users actions.

> As there's a legal requirement that OEM pre-installs not enable software
> functions tied to the Super key due to contract/legal restrictions
> involving the Windows logo, the following proposals have been made:
>
> 1. Disable the Super key function(s) in Unity by default. Re-enable the
> function when the user first initiates an action ( e.g. pressing the
> Ubuntu button ) which causes the Dash(board) to be displayed.
>
> 2. Add a Unity-specific GConf key which Unity reads to determine if the
> Super key function(s) should be disabled. This would be set to
> disabled on OEM pre-installs.

I think those two are the same proposal, the latter is just one
implementation of the former :-)

> 3. Use X11 xmodmap command to disable the Super key altogether on OEM
> pre-installs.

No, that's ruled out by the fact that users will want to enable it for
themselves.

Mark

Mark Shuttleworth (sabdfl) wrote :

 On 15/09/10 17:47, Jerone Young wrote:
> @Tony
> The problem with option #1 is we would need lawyers to qualify if it is doable using this method to meet requirement for OEMs. This would be timely process, and more then likely would not make it for the 10.10 cut off.

Best get going on that then ;-)

Bill Filler (bfiller) wrote :

Based on Mark's comments my understanding of what we will do is this:

1) Add a Unity-specific GConf key which Unity reads to determine if the
Super key function(s) should be disabled. This would be set to
disabled on OEM pre-installs but enabled otherwise.

2) First time user presses Ubuntu logo to activate the dash, enable the gconf key. This will enable the super key functionality.

Mark Shuttleworth (sabdfl) wrote :

Sounds reasonable. Need to check that it's fast-path in the common case,
though.

Mark

Neil J. Patel (njpatel) on 2010-09-17
Changed in unity:
assignee: nobody → Neil J. Patel (njpatel)
milestone: backlog → 2010-09-22
status: New → Triaged
Neil J. Patel (njpatel) on 2010-09-22
Changed in unity:
assignee: Neil J. Patel (njpatel) → Ying-Chun Liu (paulliu)
status: Triaged → Fix Committed
Launchpad Janitor (janitor) wrote :
Download full text (3.7 KiB)

This bug was fixed in the package unity - 0.2.42-0ubuntu1

---------------
unity (0.2.42-0ubuntu1) maverick; urgency=low

  * New upstream release:
    - "Applications" and "Files & Folders" tooltips are not translatable
      (LP: #644215)
    - Fix inactive menus are accessible on switching to a window (LP: #604505)
    - Fix wrong launcher tile label/quicklist x position (LP: #631446)
    - Fix highlighted items in quicklist have different widths (LP: #643315)
    - In migration tool, being safe when people are using crazy caracters in
      desktop file (LP: #644114, #635156)
    - Detect if 3D acceleration support is provided. Otherwise, prompt for
      logout and change default session (LP: #614088)
    - Fix quicklist shows hidden menu items (LP: #641543)
    - Fix removing launchers via dnd fails (LP: #643434)
    - Better launcher auto-scroll performances (LP: #640560)
    - Make the insensitive state of the forward- and back-button more obvious by
      decreasing their opacity, thus users don't assume they are actually
      clickable. (LP: #638285)
    - Fix some dialogs aren't maximized but are undecorated (LP: #628822)
    - Fix some menus don't go away when window closes (LP: #640557)
    - Fixes bug where the wrong icon where at times associated with a tile in
      the places view. (LP: #642935)
    - Speedup icon loading (LP: #641246)
    - Make trash menu items in Unity are either not translatable or translations
      are not loaded (LP: #645038)
    - Fix using dnd on launcher makes focus not work out of the unity ui
      (LP: #637123)
    - Multi-monitor support (LP: #637123)
    - Enable/disable super key by a gconf key (LP: #632581)
    - Remove glow on fold (LP: #619344)
    - Ensure we dont map windows when expose is active (LP: #599766)
    - take new indicator API for action for top-level dropdown menu item not
      activated (LP: #637692)
    - Make the home buttons reactive (LP: #638857)
    - Add red tint when search fails (LP: #607821)
    - New (and final!) UI adjustement, but UNE isn't in the doc as seen with
      the doc team (LP: #627009)
    - Single-touches on the launcher are usually interpreted as a drag
      (LP: #641328)
    - URI activation in global view (LP: #612562)
    - Clicking a Place icon while viewing the same place in the Dash should
      return to the Home screen of that place and clear the search (LP: #607829)
    - Fix mutter crashed with SIGSEGV in g_type_check_instance() (LP: #641561)
    - Fix panel and menu item font colors don't match (LP: #637480)
    - Fix indicators have orange color (LP: #632975)
    - Fix inactive menus are accessible on switching to a window (LP: #604505)
    - Use semi-transparent rectangle around launcher-icon (LP: #643388)
    - Fix mutter crashes when closing pop-up dialog (LP: #642669)
    - Change launcher icon reference size loading (LP: #641669)
    - Fix mutter crashing in mumble start (LP: #641335)
    - Fix clicking on a category from CoFs does not directly take you to the
      desired category (LP: #638402)
    - Fix some menus don't go away when window closes (LP: #640557)
    - Launchers should act like if the application was not focussed ...

Read more...

Changed in unity (Ubuntu):
status: New → Fix Released
Jerone Young (jerone) wrote :

@Neil @Ying-Chun

        What is the gconf key that was implimented, and how to enable it?

Brent Fox (brent-s-fox) wrote :

The GConf key is GCONF_SUPER_KEY_ENABLE_KEY:
http://bazaar.launchpad.net/~unity-team/unity/trunk/revision/540

I think this bug can be de-escalated from oem-priority now. OEM Svcs can create a workaround for our customers.

Changed in ayatana-design:
assignee: nobody → Oren Horev (oreneeshy)
status: New → Incomplete
Chris Van Hoof (vanhoof) on 2010-11-29
Changed in oem-priority:
status: Confirmed → Fix Released
Neil J. Patel (njpatel) on 2010-12-01
Changed in unity:
status: Fix Committed → Fix Released
Stuart Gillies (gillies) wrote :

I'm not sure where to report this, but this item seemed to be the place.

The problem is that I can't find a way (that sticks) to remap the 'super' key function to a key that I actually have. I have avoided Microsoft products for years and it is irritating to have to buy a Microsoft-defined keyboard to be able to use Unity as designed. I want to use a keyboard that does not have this extra key. Perhaps by remapping the CAPS LOCK or F9 or any other key to open the launcher.

Functions such as gconf-editor do not seem to actually work. It seems that this is even prevented by policy.

I'm using 12.04/AMD64

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers